package com.jiayue.insu.inclientqn.constant;

/**
 * 通用常量
 *
 * @author yh
 * @version 1.0
 * @since 2022/5/22 11:29
 */
public interface CommonStant {

    /**
     * 日志类型：下拉原始数据
     */
    String RECORD_TYPE_PULL_INIT = "PULL_INIT";

    /**
     * 日志类型：推送原始
     */
    String RECORD_TYPE_PUSH_INIT = "PUSH_INIT";


    /**
     * 日志类型：下拉修正数据
     */
    String RECORD_TYPE_PULL_CORRECT = "PULL_CORRECT";

    String RECORD_TYPE_PULL_CDQ_CORRECT = "PULL_CDQ_CORRECT";


    /**
     * 日志类型：下拉修正数据(嘉越修正)
     */
    String RECORD_TYPE_PULL_CORRECT_JY = "PULL_CORRECT_JY";

    /**
     * 日志类型：交互权限
     */
    String RECORD_TYPE_COM_PERMISSON = "COM_PERMISSON";

    /**
     * 日志类型：回传文件解析
     */
    String RECORD_TYPE_BACK_DATA_FILE = "BACK_DATA_FILE";


    /**
     * 日志类型：回传超短期文件解析
     */
    String RECORD_TYPE_CDQ_BACK_DATA_FILE = "BACK_CDQ_DATA_FILE";

    /**
     * 日志类型：回传实际功率
     */
    String RECORD_TYPE_REAL_VALUE_FOR_JY = "BACK_REAL_VALUE_DATA";

    /**
     *  武穴一体化场站标识
     */
    String RECORD_TYPE_CDQ_FILE = "HGRXGG";

    /**
     * 日志类型：回传理论可用文件解析
     */
    String RECORD_TYPE_BACK_DATA_LLKY_FILE = "BACK_DATA_LLKY_FILE";

    /**
     * 日志类型：回传数据
     */
    String RECORD_TYPE_BACK_DATA = "BACK_DATA";

    /**
     * 日志类型：回传数据(理论可用)
     */
    String RECORD_TYPE_BACK_LLkY_DATA = "BACK_LLkY_DATA";

    /**
     * 日志类型：修正数据
     */
    String RECORD_TYPE_CORRECT_DATA = "CORRECT_DATA";
    /**
     * 换行
     */
    String LINE_CONSTANT ="\n";
    /**
     * 空格1
     */
    String SPACE1_CONSTANT = " ";
    /**
     * 空格2
     */
    String SPACE2_CONSTANT = "  ";
    /**
     * 空格3
     */
    String SPACE3_CONSTANT = "   ";
    /**
     * 空格4
     */
    String SPACE4_CONSTANT = "    ";


    String ET_PHOTOVOLTAIC = "E1";

    String ET_WIND = "E2";


    /**
     * 上午
     */
    String AM_DAY ="AM";
    /**
     * 下午
     */
    String PM_DAY = "PM";
    /**
     * 定时任务类型：公有
     */
    String JOB_TYPE_PUBLIC= "PUBLIC";
    /**
     * 定时任务类型：私有 （公司所有）
     */
    String JOB_TYPE_PRIVATE= "PRIVATE";
}
