package com.jiayue.insu.inclientqn.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.jiayue.insu.inclientqn.entity.BackStatData;

import java.time.LocalDateTime;
import java.util.List;

/**
 * 回传统计数据接口
 *
 * @author yh
 * @version 1.0
 * @since 2022/5/22 11:29
 */
public interface BackStatDataService extends IService<BackStatData> {

    List<BackStatData> findBySignTime(LocalDateTime time);

    List<BackStatData> findBySignTimeBetween(LocalDateTime startTime,LocalDateTime endTime);



}
