package com.jiayue.insu.incloud.constants.dto;

import lombok.Data;

import java.util.List;

/**
 * 北京中央研究院（山东）上送数据参数dto
 *
 * @Author: tl
 * @Date: 2023/12/14 13:43
 */
@Data
public class BJZYYJYSDPushDqDataParamsDto {

    /**
     * 租户id
     */
    private String farm_id;
    /**
     * 开始时间
     */
    private String start_time;
    /**
     * 预测厂家
     */
    private String forecaster;
    /**
     * 更新时间
     */
    private String updateTime;
    /**
     * 预测日期
     */
    private List<String> forecast_days;
    /**
     * 预测时间和数据
     */
    private List<List<List<Object>>> forecast_data;


    public BJZYYJYSDPushDqDataParamsDto(String farm_id, String start_time, String forecaster, String updateTime, List<String> forecast_days, List<List<List<Object>>> forecast_data) {
        this.farm_id = farm_id;
        this.start_time = start_time;
        this.forecaster = forecaster;
        this.updateTime = updateTime;
        this.forecast_days = forecast_days;
        this.forecast_data = forecast_data;

    }

    public BJZYYJYSDPushDqDataParamsDto() {
    }
}
