package com.jiayue.insu.incloud.constants.dto;

import lombok.Data;

import java.util.List;

/**
 * 飔合科技（辽宁）上送数据参数dto
 *
 * @Author: tl
 * @Date: 2023/12/14 13:43
 */
@Data
public class SHKJLNPushDqDataParamsDto {

    public SHKJLNPushDqDataParamsDto(String station_id, String forecast_date, List<DataPointDTO> data) {
        this.station_id = station_id;
        this.forecast_date = forecast_date;
        this.data = data;
    }

    /**
     * id
     */
    private String station_id;
    /**
     * 预测日期
     */
    private String forecast_date;

    /**
     * 预测时间和数据
     */
    private List<DataPointDTO> data;



    @Data
    public static class DataPointDTO {
        private double power;
        private String time;
    }
}

