package com.jiayue.insu.incloud.constants.vo;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;


/**
 * 林祥上送数据VO
 *
 * @author yh
 * @version 1.0
 * @since 2022/5/22 11:29
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
public class ResponseLXVo {

    /**
     * 响应码
     */
    private String code;

    /**
     * 响应信息
     */
    private String message;

    /**
     *  是否成功
     */
    private Long timestamp;

    /**
     * 响应数据
     */
    private Boolean data;
}
