package com.jiayue.insu.incloud.constants.vo;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;


/**
 * 北京中央研究院（山东）上送数据响应VO
 *
 * @author yh
 * @version 1.0
 * @since 2022/5/22 11:29
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
public class ResponseSDVo {

    /**
     * 响应码
     */
    private String code;
    /**
     * 响应信息
     */
    private String msg;

    /**
     * 响应数据
     */
    private String data;
}
