package com.jiayue.insu.incloud.entity;


import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.math.BigDecimal;


/**
 * 预测数据实体
 *
 * @author yh
 * @version 1.0
 * @since 2020/7/8 10:56
 */

@TableName(value = "in_power_station_status_data")
@Data
public class PowerStationStatusData {

    //id
    @TableId(type = IdType.AUTO)
    private Long id;

    // 场站编号
    private String stationCode;

    //生成时间
    private Long genDate;

    //预测时间
    private Long forecastTime;

    //实际功率
    private BigDecimal realValue;

}
