package com.jiayue.insu.incloud.entity;


import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.time.LocalDateTime;


/**
 * 预测数据实体
 *
 * @author yh
 * @version 1.0
 * @since 2020/7/8 10:56
 */

@TableName(value = "in_ultra_short_term")
@Data
public class UltraShortTerm {

    // id
    @TableId(type = IdType.AUTO)
    private Long id;

    // 场站编号
    private String stationCode;

    //生成时间
    private Long genDate;

    //预测时间
    private Long forecastTime;

    // 预测功率
    private BigDecimal fpValue;

}
