package com.jiayue.insu.incloud.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.jiayue.insu.incloud.entity.ForecastData;
import com.jiayue.insu.incloud.entity.PowerGeneration;
import com.jiayue.insu.incloud.entity.PowerStationStatusData;
import com.jiayue.insu.incloud.entity.Station;

import java.time.LocalDateTime;
import java.util.Date;
import java.util.List;

/**
 * 发电量预测业务接口
 *
 * @author yh
 * @version 1.0
 * @since 2022/5/22 11:29
 */
public interface PowerGenerationService extends IService<PowerGeneration> {
    Boolean generatePower(LocalDateTime nowDate, String stationCode);

    List<PowerGeneration> findByStationCodeAndInitTime(String stationCode, Date date);

}
