package com.jiayue.passback.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.jiayue.passback.entity.eunm.ElectricFieldTypeEnum;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;

/**
 * 场站实体
 *
 * @author yh
 * @version 1.0
 * @since 2019/7/22 11:16
 */
@EqualsAndHashCode(callSuper = true)
@Data
@TableName("T_ACCURACY_PASS_RATE")
public class AccuracyPassRate extends AbstractBaseEntity {

    @TableId(value="C_ID",type = IdType.AUTO)
    private Integer id;

    /**
     * 短期准确率
     */
    @TableField("C_SHORT_TERM_ACCURACY")
    private String shortTermAccuracy;


    /**
     * 短期准确率
     */
    @TableField("C_TIME")
    private Long time;

}
