package com.jiayue.passback.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

/**
 * 参数实体
 *
 * @author zcl
 * @version 1.0
 * @since 2023/04/10 11:29
 */
@Data
@TableName("t_sys_parameter")
public class SysParameter extends AbstractBaseEntity {

    @TableId("C_ID")
    private Integer id;

    /**
     * 参数标识
     */
    @TableField("C_SYS_KEY")
    private String sysKey;

    /**
     * 参数值
     */
    @TableField("C_SYS_VALUE")
    private String sysValue;

    /**
     * 参数描述
     */
    @TableField("C_DESCRIBE")
    private String describes;

    /**
     * 场站标识
     */
    @TableField("C_STATION_CODE")
    private String stationCode;

}
