package com.jiayue.insu.inclientqn.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * 修正数据 超短期修正比例
 *
 * @author yh
 * @version 1.0
 * @since 2018/12/7 16:22
 */
@Data
@TableName("in_correct_us_data")
public class CorrectUltraShortTerm extends  BaseCorrectTime {

    /**
     * Id
     */
    @TableId(type = IdType.AUTO)
    Long id;
    /**
     * 预测时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    LocalDateTime forecastTime;
    /**
     * 修正比例
     */
    BigDecimal ratio;

    BigDecimal correctValue;
}
