package com.jiayue.insu.inclientqn.model;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

/**
 * @description: 山东国家研究院一体化响应VO
 * @author: fxy
 * @createDate: 2023/12/15
 * @version: 1.0
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
public class BJZYYJYSDResponseVo {

    /**
     * 响应码
     */
    private String code;
    /**
     * 响应信息
     */
    private String msg;

    /**
     * 响应数据
     */
    private String data;
}
