package com.jiayue.insu.inclientqn.model;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.io.Serializable;

/**
 * @description:
 * @author: yuanhao
 * @createDate: 2021/8/23
 * @version: 1.0
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
public class BJZYYJYSDTokenVo implements Serializable {

    /**
     * 访问令牌
     */
    private String access_token;

    /**
     * 刷新 token
     */
    private String refresh_token;

    /**
     * 过期时间，12 小时
     */
    private Long expires_in;
    /**
     * 授权范围
     */
    private String scope;
    /**
     * 用户详细信息
     */
    private String user_info;;
}
