package com.jiayue.insu.inclientqn.model;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

/**
 * @description: 武穴一体化响应VO
 * @author: fxy
 * @createDate: 2023/12/15
 * @version: 1.0
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
public class WXResponseVo {

    /**
     * 响应码
     */
    private String statusCode;
    /**
     * 响应信息
     */
    private String message;

    /**
     * 相应结果
     */
    private String result;
    /**
     * 响应数据
     */
    private String data;
}
