package com.jiayue.insu.inclientqn.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.jiayue.insu.inclientqn.entity.BackForeUsForecastData;

import java.time.LocalDateTime;
import java.util.List;

/**
 * 回传预测超短期数据接口
 *
 * @author yh
 * @version 1.0
 * @since 2022/5/22 11:29
 */
public interface BackForeUsForecastDataService extends IService<BackForeUsForecastData> {

    List<BackForeUsForecastData> findBySignTime(LocalDateTime time);

    List<BackForeUsForecastData> findBySignTimeAndStationCode(LocalDateTime time,String stationCode);


}
