package com.jiayue.insu.incloud.constants.vo;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;


/**
 * 北京中央研究院（山东）token响应VO
 *
 * @Author: tl
 * @Date: 2023/12/14 9:56
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
public class BJZYYJYSDTokenVo {

    /**
     * 访问令牌
     */
    private String access_token;

    /**
     * 刷新 token
     */
    private String refresh_token;

    /**
     * 过期时间，12 小时
     */
    private Long expires_in;
    /**
     * 授权范围
     */
    private String scope;
    /**
     * 用户详细信息
     */
    private String user_info;
}
