package com.jiayue.insu.incloud.constants.vo;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;


/**
 * 飔合科技（辽宁）上送/请求修正数据响应VO
 *
 * @author yh
 * @version 1.0
 * @since 2022/5/22 11:29
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
public class ResponseSHLNVo {

    /**
     * 响应码
     */
    private String code;

    /**
     * 响应信息
     */
    private String message;

    /**
     *  是否成功
     */
    private Boolean success;

    /**
     *  场站id
     */
    private String station_id;

    /**
     * 响应数据
     */
    private String data;
}
