package com.jiayue.insu.incloud.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.jiayue.insu.incloud.entity.MonthPowerGeneration;

import java.time.LocalDateTime;
import java.util.Date;
import java.util.List;

/**
 * 月发电量预测业务接口
 *
 * @author yh
 * @version 1.0
 * @since 2022/5/22 11:29
 */
public interface MonthPowerGenerationService extends IService<MonthPowerGeneration> {

    boolean generatePower(LocalDateTime initTime, String stationCode);

    List<MonthPowerGeneration> findByGenDateAndStationCode(Date genDate,String stationCode);
}
