package com.jiayue.passback.constants;

/**
 * 通用常量
 *
 * @author yh
 * @version 1.0
 * @since 2022/5/22 11:29
 */
public interface CommonStant {

    /**
     * 日志类型：下拉原始数据
     */
    String RECORD_TYPE_PULL_INIT = "PULL_INIT";

    /**
     * 日志类型：推送原始
     */
    String RECORD_TYPE_PUSH_INIT = "PUSH_INIT";

    /**
     * 日志类型：下拉修正数据
     */
    String RECORD_TYPE_PULL_CORRECT = "PULL_CORRECT";

    /**
     * 日志类型：下拉修正数据
     */
    String RECORD_TYPE_PUSH_CORRECT_TO_MIN_IO = "PUSH_CORRECT_TO_MIN_IO";

    /**
     * 日志类型：交互权限
     */
    String RECORD_TYPE_COM_PERMISSON = "COM_PERMISSON";

    /**
     * 换行
     */
    String LINE_CONSTANT = "\n";
    /**
     * 空格1
     */
    String SPACE1_CONSTANT = " ";
    /**
     * 空格2
     */
    String SPACE2_CONSTANT = "  ";
    /**
     * 空格3
     */
    String SPACE3_CONSTANT = "   ";
    /**
     * 空格4
     */
    String SPACE4_CONSTANT = "    ";

    /**
     * 冒号
     */
    String CHARACTER_COLON = ":";

    /**
     * 秒补0
     */
    String CHARACTER_TIME_ZERO = ":00";

    /**
     * 光伏
     */
    String ET_PHOTOVOLTAIC = "E1";

    /**
     * 风电
     */
    String ET_WIND = "E2";

    /**
     * 上午
     */
    String AM_DAY = "AM";
    /**
     * 下午
     */
    String PM_DAY = "PM";
    /**
     * 定时任务类型：公有
     */
    String JOB_TYPE_PUBLIC = "PUBLIC";
    /**
     * 定时任务类型：私有 （公司所有）
     */
    String JOB_TYPE_PRIVATE = "PRIVATE";

    /**
     * redis 中存放用于token验证的用户及密码
     */
    String REDIS_USERS = "integration:cloud:users";
    /**
     * redis 中存放用户的token
     */
    String REDIS_USER_TOKEN = "integration:cloud:userToken";

    /**
     * 请求的用户名
     */
    String REQUEST_USER_NAME = "requestUserName";

    /**
     * 请求的密码
     */
    String REQUEST_USER_PASS = "requestUserPass";

    /**
     * token
     */
    String TOKEN = "token";

    /**
     * 授权
     */
    String AUTHORIZATION = "Authorization";


}
